#include "Water_DLL.h"

//Copyright (C) cocosimulator.org 2023
//generated by AmsterCHEM's COM CAPE-OPEN Wizard

class LockObject {
	//this class should not be used directly. Use a Locker() class instead, this will lock in the scope that it is created in
	void Lock();
	void Unlock();
	friend class Locker;
	DWORD threadID; //thread that has the lock; Locker uses this to prevent spin locks
public:
	LockObject();
	~LockObject();
};

CRITICAL_SECTION TheCriticalSection;
LockObject theLock; 

LockObject::LockObject() {
	threadID=0;
	InitializeCriticalSection(&TheCriticalSection);
}

LockObject::~LockObject() {
	DeleteCriticalSection(&TheCriticalSection);
}

void LockObject::Lock() {
	EnterCriticalSection(&TheCriticalSection);
	threadID=GetCurrentThreadId();
}

void LockObject::Unlock() {
	threadID=0;
	LeaveCriticalSection(&TheCriticalSection);
}

Locker::Locker() {
	locked=false;
	if (theLock.threadID!=GetCurrentThreadId()) {
		theLock.Lock();
		locked=true;
	}
}

Locker::~Locker() {
	if (locked) theLock.Unlock();
}

#ifdef _DEBUG
bool Locker::IsThreadLocked() {
	return (theLock.threadID==GetCurrentThreadId());
}
#endif
